using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using ISummary = Syncfusion.Collections.BinaryTree.ITreeTableSummary;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using CustomSummary;

namespace GroupingWithDataGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		private const int DATA_ROWS = 1000;
		private const string SELECTED = "Selected";
		private const string SECTOR = "Sector";
		private const string SECTOR_MAJOR = "Sector (Major)";
		private const string ASSET = "Asset";
		private const string CURRENCY = "Currency";		
		private const string POSITION = "Position";
		private const string POSITIONADJ = "PositionAdj";
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl3;
		private System.Windows.Forms.CheckBox checkBox3;
		private System.Windows.Forms.CheckBox checkBox5;
		private System.Windows.Forms.CheckBox checkBox6;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.CheckBox checkBox2;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.CheckBox checkBox7;
		private System.Windows.Forms.Button expand;
		private System.Windows.Forms.Button collapse;
		private System.Windows.Forms.CheckBox checkBox8;
		private System.Windows.Forms.CheckBox checkBox4;
		

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl3 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.checkBox3 = new System.Windows.Forms.CheckBox();
			this.checkBox4 = new System.Windows.Forms.CheckBox();
			this.checkBox5 = new System.Windows.Forms.CheckBox();
			this.checkBox6 = new System.Windows.Forms.CheckBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.checkBox7 = new System.Windows.Forms.CheckBox();
			this.expand = new System.Windows.Forms.Button();
			this.collapse = new System.Windows.Forms.Button();
			this.checkBox8 = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl3
			// 
			this.gridGroupingControl3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.gridGroupingControl3.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.gridGroupingControl3.ChildGroupOptions.CaptionText = "{Category} ";
			this.gridGroupingControl3.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gridGroupingControl3.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl3.Name = "gridGroupingControl3";
			this.gridGroupingControl3.ShowNavigationBar = true;
			this.gridGroupingControl3.ShowNavigationBarToolTips = true;
			this.gridGroupingControl3.Size = new System.Drawing.Size(688, 448);
			this.gridGroupingControl3.TabIndex = 11;
			this.gridGroupingControl3.TableDescriptor.AllowNew = false;
			this.gridGroupingControl3.TableDescriptor.AllowRemove = false;
			this.gridGroupingControl3.TableDescriptor.Name = "Default";
			this.gridGroupingControl3.TableOptions.ShowRowHeader = false;
			this.gridGroupingControl3.TableOptions.ShowTreeLines = true;
			this.gridGroupingControl3.Text = "gridGroupingControl3";
			this.gridGroupingControl3.TopLevelGroupOptions.ShowCaption = false;
			this.gridGroupingControl3.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl3_QueryCellStyleInfo);
			// 
			// checkBox3
			// 
			this.checkBox3.Location = new System.Drawing.Point(704, 8);
			this.checkBox3.Name = "checkBox3";
			this.checkBox3.Size = new System.Drawing.Size(160, 16);
			this.checkBox3.TabIndex = 12;
			this.checkBox3.Text = "Child Group Full Captions";
			this.checkBox3.CheckedChanged += new System.EventHandler(this.checkBox3_CheckedChanged);
			// 
			// checkBox4
			// 
			this.checkBox4.Location = new System.Drawing.Point(704, 24);
			this.checkBox4.Name = "checkBox4";
			this.checkBox4.Size = new System.Drawing.Size(160, 16);
			this.checkBox4.TabIndex = 15;
			this.checkBox4.Text = "Apply Grouping Style";
			this.checkBox4.CheckedChanged += new System.EventHandler(this.checkBox4_CheckedChanged);
			// 
			// checkBox5
			// 
			this.checkBox5.Location = new System.Drawing.Point(704, 40);
			this.checkBox5.Name = "checkBox5";
			this.checkBox5.Size = new System.Drawing.Size(160, 16);
			this.checkBox5.TabIndex = 16;
			this.checkBox5.Text = "Apply Column Style";
			this.checkBox5.CheckedChanged += new System.EventHandler(this.checkBox5_CheckedChanged);
			// 
			// checkBox6
			// 
			this.checkBox6.Location = new System.Drawing.Point(704, 56);
			this.checkBox6.Name = "checkBox6";
			this.checkBox6.Size = new System.Drawing.Size(160, 16);
			this.checkBox6.TabIndex = 17;
			this.checkBox6.Text = "Apply CheckBox Style";
			this.checkBox6.CheckedChanged += new System.EventHandler(this.checkBox6_CheckedChanged);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(704, 72);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(160, 16);
			this.checkBox1.TabIndex = 18;
			this.checkBox1.Text = "Apply DataRow Style";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// checkBox2
			// 
			this.checkBox2.Location = new System.Drawing.Point(704, 88);
			this.checkBox2.Name = "checkBox2";
			this.checkBox2.Size = new System.Drawing.Size(160, 16);
			this.checkBox2.TabIndex = 19;
			this.checkBox2.Text = "Set Col Widths";
			this.checkBox2.CheckedChanged += new System.EventHandler(this.checkBox2_CheckedChanged);
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.gridGroupingControl1.ChildGroupOptions.CaptionText = "{Category} ";
			this.gridGroupingControl1.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.gridGroupingControl1.Location = new System.Drawing.Point(720, 168);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(120, 136);
			this.gridGroupingControl1.TabIndex = 20;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.TableDescriptor.AllowRemove = false;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.TableOptions.ShowRowHeader = false;
			this.gridGroupingControl1.TableOptions.ShowTreeLines = true;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
			// 
			// checkBox7
			// 
			this.checkBox7.Location = new System.Drawing.Point(704, 104);
			this.checkBox7.Name = "checkBox7";
			this.checkBox7.Size = new System.Drawing.Size(160, 16);
			this.checkBox7.TabIndex = 21;
			this.checkBox7.Text = "MergeCaptions";
			this.checkBox7.CheckedChanged += new System.EventHandler(this.checkBox7_CheckedChanged);
			// 
			// expand
			// 
			this.expand.Location = new System.Drawing.Point(704, 432);
			this.expand.Name = "expand";
			this.expand.Size = new System.Drawing.Size(24, 23);
			this.expand.TabIndex = 22;
			this.expand.Text = "+";
			this.expand.Click += new System.EventHandler(this.expand_Click);
			// 
			// collapse
			// 
			this.collapse.Location = new System.Drawing.Point(736, 432);
			this.collapse.Name = "collapse";
			this.collapse.Size = new System.Drawing.Size(24, 23);
			this.collapse.TabIndex = 23;
			this.collapse.Text = "-";
			this.collapse.Click += new System.EventHandler(this.collapse_Click);
			// 
			// checkBox8
			// 
			this.checkBox8.Location = new System.Drawing.Point(704, 120);
			this.checkBox8.Name = "checkBox8";
			this.checkBox8.Size = new System.Drawing.Size(144, 16);
			this.checkBox8.TabIndex = 24;
			this.checkBox8.Text = "Apply Empty Style";
			this.checkBox8.CheckedChanged += new System.EventHandler(this.checkBox8_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(872, 461);
			this.Controls.Add(this.checkBox8);
			this.Controls.Add(this.collapse);
			this.Controls.Add(this.expand);
			this.Controls.Add(this.checkBox7);
			this.Controls.Add(this.gridGroupingControl1);
			this.Controls.Add(this.checkBox2);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.checkBox6);
			this.Controls.Add(this.checkBox5);
			this.Controls.Add(this.checkBox4);
			this.Controls.Add(this.checkBox3);
			this.Controls.Add(this.gridGroupingControl3);
			this.Name = "Form1";
			this.Text = "Grid Grouping";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try
			{
				Application.Run(new Form1());
			}
			catch (Exception exp)
			{
				MessageBox.Show(exp.ToString());
			}
		}

		//our datasource
		DataTable myTable;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//get a DataTable
			myTable = GetATable();

			// GRID 3
			this.gridGroupingControl3.DataSource = myTable;
			this.gridGroupingControl3.TableDescriptor.GroupedColumns.Add(SECTOR_MAJOR);
			this.gridGroupingControl3.TableDescriptor.GroupedColumns.Add(SECTOR);
			this.gridGroupingControl3.TableDescriptor.GroupedColumns.Add(CURRENCY);


			SortColumnDescriptor sortBy = new SortColumnDescriptor(ASSET);
			this.gridGroupingControl3.TableDescriptor.SortedColumns.Add(sortBy);

			gridGroupingControl3.TableOptions.ColumnHeaderRowHeight = 32;//25 by default givs us room for 2 lines

			// Select only one at a time
			gridGroupingControl3.TableDescriptor.TableOptions.ListBoxSelectionMode = SelectionMode.One;
			gridGroupingControl3.TableOptions.AllowSelection |= GridSelectionFlags.AlphaBlend | GridSelectionFlags.Row;
  
			// make everhytitng Static for readonly - need to alter the adjsuted cols
			gridGroupingControl3.TableDescriptor.Appearance.AnyRecordFieldCell.CellType = "Static";

			// Hide the corder around the current cell - looks naff on readonyl
			//gridGroupingControl3.TableModel.Options.ShowCurrentCellBorderBehavior = GridShowCurrentCellBorder.HideAlways;

			//color rows and alternates rows if they are selected
//			GridConditionalFormatDescriptor formatSelected = new GridConditionalFormatDescriptor("selected");
//			formatSelected.Expression = "[SELECTED] == true";
//			formatSelected.Appearance.AlternateRecordFieldCell.BackColor = Color.Blue;
//			formatSelected.Appearance.AnyRecordFieldCell.BackColor = Color.Blue;
//			gridGroupingControl3.TableDescriptor.ConditionalFormats.Add(formatSelected);
			
			CreateSummaryColumns();
		}

		private void CreateSummaryColumns()
		{
			GridTableDescriptor tdParent = gridGroupingControl3.TableDescriptor;
			GridTableDescriptor tdChild = tdParent;

			//add summary row to child
			GridSummaryColumnDescriptor[] sumCols = new GridSummaryColumnDescriptor[2];

			GridSummaryColumnDescriptor posSummary = new GridSummaryColumnDescriptor(POSITION);
			posSummary.DataMember = POSITION;
			posSummary.DisplayColumn = POSITION;
			posSummary.Style = GridSummaryStyle.Column;
			posSummary.Format = "{Sum:#.00}";
			posSummary.SummaryType = SummaryType.DoubleAggregate;
			sumCols[0] = posSummary;

			GridSummaryColumnDescriptor posAdjSummary = new GridSummaryColumnDescriptor(POSITIONADJ);
			posAdjSummary.DataMember = POSITIONADJ;
			posAdjSummary.DisplayColumn = POSITIONADJ;
			posAdjSummary.Style = GridSummaryStyle.Column;
			posAdjSummary.Format = "{Sum:#.00}";
			posAdjSummary.SummaryType = SummaryType.DoubleAggregate;
			sumCols[1] = posAdjSummary;

			GridSummaryRowDescriptor sRow = new GridSummaryRowDescriptor("Totals", sumCols);
			sRow.Visible = false;
			tdChild.SummaryRows.Add(sRow);
			tdChild.Appearance.AnySummaryCell.HorizontalAlignment = GridHorizontalAlignment.Right;

			tdParent.SummaryRows.Add(sRow);
			//tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionSummaryCell.BackColor = Color.Red; //tdParent.Appearance.RecordFieldCell.BackColor;
//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionCell.CellType = "Static";
//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.AnyGroupCell.VerticalAlignment = GridVerticalAlignment.Middle;
//			tdParent.Columns[SECTOR_MAJOR].GroupByAppearance.GroupCaptionCell.Borders.All = new GridBorder(GridBorderStyle.Standard);

			tdParent.ChildGroupOptions.CaptionText = "{Category}";
			tdParent.ChildGroupOptions.ShowCaptionSummaryCells = true;
			tdParent.ChildGroupOptions.CaptionSummaryRow = "Totals";

			gridGroupingControl3.TableOptions.ShowTableRowHeaderAsCoveredRange = true;

		}

		private DataTable GetATable()
		{
			DataTable dt = new DataTable("MyTable");
			
			dt.Columns.Add(new DataColumn(SECTOR_MAJOR, typeof(string)));
			dt.Columns.Add(new DataColumn(SECTOR, typeof(string)));
			dt.Columns.Add(new DataColumn(CURRENCY, typeof(string)));
			dt.Columns.Add(new DataColumn(ASSET, typeof(string)));
			dt.Columns.Add(new DataColumn(SELECTED, typeof(bool)));
			dt.Columns.Add(new DataColumn(POSITION, typeof(int)));		
			dt.Columns.Add(new DataColumn(POSITIONADJ, typeof(int)));		

			PopulateDataTable(dt);

			return dt;
		}

		private void PopulateDataTable(DataTable dt)
		{
			//			if (this.gridGroupingControl1.TableModel.cur.CreateControl.CurrentRowIndex >= 0)
			//				this.dataGrid1.CurrentRowIndex = 0;
			dt.Clear();
			dt.Rows.Clear();

			Random r = new Random();

			for(int i = 0; i < DATA_ROWS; i++)
			{
				DataRow dr = dt.NewRow();
	
				string sectorMajor = "";
				string sector = "";

				string asset = "";
				switch (r.Next(5))
				{
					case 0:
						asset = "MS 07/15/09";
						break;
					case 1:
						asset = "BT 05/15/08";
						break;
					case 2:
						asset = "EMAP";
						break;
					case 3:
						asset = "ALLIED 0% 03-01-14";
						break;
					case 4:
						asset = "CELL  08-01-11";
						break;
					default:
						asset = "ABIT INC 08-01-09";
						break;
				}
				asset += " " + i.ToString("00000");

				switch (r.Next(3))
				{
					case 0:
						sectorMajor = "Asset Backed";
						switch (r.Next(3))
						{
							case 0:
								sector = "Asset Back Securities";
								break;
							case 1:
								sector = "Credit Card";
								break;
							default:
								sector = "Other";
								break;
						}
						break;

					case 1:
						sectorMajor = "Corporates";
						switch (r.Next(3))
						{
							case 0:
								sector = "Automobiles & Components";
								break;
							case 1:
								sector = "Banks";
								break;
							default:
								sector = "Captial Goods";
								break;
						}
						break;

					default:
						sectorMajor = "Mortgage Backed";
						switch (r.Next(3))
						{
							case 0:
								sector = "Mortgage-Backed Securities";
								break;
							case 1:
								sector = "Public Sector";
								break;
							case 2:
								sector = "Private Sector";
								break;
						}
						break;
				}

				string currency = "";
				switch (r.Next(3))
				{
					case 0:
						currency = "USD";
						break;
					case 1:
						currency = "EURO";
						break;
					case 2:
						currency = "GBP";
						break;
				}

				dr[SECTOR_MAJOR] = sectorMajor;
				dr[SECTOR] = sector;
				dr[ASSET] = asset;
				dr[CURRENCY] = currency;

				int itemPosition = r.Next(1000);
				dr[POSITION] = itemPosition;

				// adjust pos for first 10
				if (i< 10)
				{
					dr[POSITIONADJ] = itemPosition + i;
				}

				dt.Rows.Add(dr);
			}
		}

		private void checkBox3_CheckedChanged(object sender, System.EventArgs e)
		{
			string caption;
			if (checkBox3.Checked)
			{
				caption = "{CategoryName}: {Category}";
			}
			else
			{
				caption = "{Category}";
			}

			//gridGroupingControl3.ChildGroupOptions.CaptionText = caption;
			GridTableDescriptor tdParent = gridGroupingControl3.TableDescriptor;
			tdParent.ChildGroupOptions.CaptionText = caption;//"{Category}";
			
		}


		private void checkBox4_CheckedChanged(object sender, System.EventArgs e)
		{

			if (checkBox4.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				newStyle.BackColor = Color.Wheat;
				newStyle.Enabled = false;
				newStyle.ReadOnly = true;
				newStyle.Font.Bold = true;
				gridGroupingControl3.TableDescriptor.Appearance.AnyGroupCell = newStyle;
				gridGroupingControl3.TableDescriptor.Appearance.GroupCaptionSummaryCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl3.TableDescriptor.Appearance.AnyGroupCell);
			}
			 
		}

		private void ResetStyle(GridTableCellStyleInfo style)
		{
			style.ResetInterior();
			style.ResetCellType();
			style.ResetFont();
			style.ResetHorizontalAlignment();
		}

		private void checkBox5_CheckedChanged(object sender, System.EventArgs e)
		{
			// column headers
			if (checkBox5.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				newStyle.CellAppearance = GridCellAppearance.Raised;
				newStyle.BackColor = Color.Silver;
				newStyle.Font.Bold = true;
				gridGroupingControl3.TableDescriptor.Appearance.ColumnHeaderCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl3.TableDescriptor.Appearance.ColumnHeaderCell);
			}		
		}

		private void checkBox6_CheckedChanged(object sender, System.EventArgs e)
		{
			gridGroupingControl3.TableDescriptor.Columns[SELECTED].Width = 20;
			gridGroupingControl3.TableDescriptor.Columns[SELECTED].HeaderText ="Select";
			gridGroupingControl3.TableDescriptor.Columns[SELECTED].Appearance.AnyRecordFieldCell.CellType = "CheckBox";
			//gridGroupingControl3.TableDescriptor.Appearance.AnyRecordFieldCell.CellType = "Static";
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox1.Checked)
			{
				GridTableCellStyleInfo recordStyle = new GridTableCellStyleInfo();
				recordStyle.BackColor = Color.LightCyan;//.PowderBlue;
				recordStyle.Font.Bold = false;
				gridGroupingControl3.TableDescriptor.Appearance.RecordFieldCell = recordStyle;

				GridTableCellStyleInfo altRecordStyle = new GridTableCellStyleInfo();
				altRecordStyle.BackColor = Color.LightCyan;
				altRecordStyle.Font.Bold = false;
				gridGroupingControl3.TableDescriptor.Appearance.AlternateRecordFieldCell = altRecordStyle;

			}
			else
			{
				ResetStyle(gridGroupingControl3.TableDescriptor.Appearance.RecordFieldCell);
				ResetStyle(gridGroupingControl3.TableDescriptor.Appearance.AlternateRecordFieldCell);
			}			
		}

		private void checkBox2_CheckedChanged(object sender, System.EventArgs e)
		{
			if (checkBox2.Checked)
			{
				gridGroupingControl3.TableDescriptor.Columns[ASSET].Width = 450;
			}
			else
			{
				gridGroupingControl3.TableDescriptor.Columns[ASSET].Reset();

			}
		}

		private void checkBox7_CheckedChanged(object sender, System.EventArgs e)
		{
			gridGroupingControl3.TableModel.CoveredRanges.Clear();

			if (checkBox7.Checked)
			{
				gridGroupingControl3.TableDescriptor.Columns[POSITION].HeaderText = "2219 ADG AHIT";

				this.gridGroupingControl3.TableModel.QueryCoveredRange += 
					new Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);
			}
			else
			{
				this.gridGroupingControl3.TableModel.QueryCoveredRange -= 
					new Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventHandler(TableModel_QueryCoveredRange);
			}
			
			gridGroupingControl3.Refresh();

		}

		private void TableModel_QueryCoveredRange(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCoveredRangeEventArgs e)
		{
			GridTableModel tm = sender as GridTableModel;
			Element el = tm.Table.DisplayElements[e.RowIndex];

			if (el is CaptionRow)
			{
				GridTableCellStyleInfo style = tm[e.RowIndex, e.ColIndex];
				int maxCaptionColCount = Math.Max(tm.Table.TableDescriptor.GetColumnIndentCount(), tm.Table.TableDescriptor.GetColCount()-1);
				int startCol = el.GroupLevel+1;
				maxCaptionColCount = Math.Min(5+1, maxCaptionColCount);
				IGridGroupOptionsSource g = el.ParentGroup as IGridGroupOptionsSource;
				if (g != null && !g.GroupOptions.ShowCaptionPlusMinus)
				{
					startCol--;
				}
				int d = (el.ParentTable.RelatedTables.Count > 0) ? 1 : 0;
				if (!((GridTable) el.ParentTable).TableOptions.ShowRecordPlusMinus)
					d = 0;
				if (e.ColIndex >= startCol && e.ColIndex <= maxCaptionColCount)
				{
					e.Range = GridRangeInfo.Cells(e.RowIndex, startCol, e.RowIndex, maxCaptionColCount);
					e.Handled = true;
				}
			}

		}

		private void expand_Click(object sender, System.EventArgs e)
		{
			gridGroupingControl3.Table.ExpandAllGroups();
		}

		private void collapse_Click(object sender, System.EventArgs e)
		{
			gridGroupingControl3.Table.CollapseAllGroups();
		}

		private void expandRecords_Click(object sender, System.EventArgs e)
		{
			gridGroupingControl3.Table.ExpandAllRecords();
		}

//		private void gridGroupingControl3_QueryCustomSummary(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryCustomSummaryEventArgs e)
//		{
//
//			switch (e.SummaryColumn.Name)
//			{
//				case "QuantityTotal":
//				{
//					e.SummaryDescriptor.CreateSummaryMethod = new CreateSummaryDelegate(TotalSummary.CreateSummaryMethod);
//					break;
//				}
//			}
//		}

		private void gridGroupingControl3_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if (
				(
				 e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell 
				 || 
				 e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell
				)
				&&
				(
				 e.TableCellIdentity.Column.Name == SECTOR_MAJOR
				 ||
				 e.TableCellIdentity.Column.Name == SECTOR
				)
				)
			{
				//e.Style.CellValue = "";
			}
		}

		private void checkBox8_CheckedChanged(object sender, System.EventArgs e)
		{

			if (checkBox8.Checked)
			{
				GridTableCellStyleInfo newStyle = new GridTableCellStyleInfo();
				//newStyle.CellAppearance = GridCellAppearance.Raised;
				newStyle.BackColor = Color.Red;
				//newStyle.Font.Bold = true;
				gridGroupingControl3.TableDescriptor.Appearance.AnySummaryCell = newStyle;
			}
			else
			{
				ResetStyle(gridGroupingControl3.TableDescriptor.Appearance.AnySummaryCell);
			}	
		}


	}
}
